﻿// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.6
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Esmf
{
    [Serializable]
    public abstract class ParameterElement<T> : NonTypedParameterElement
    {
        public abstract T GetBestGuessValue();

        public abstract T GetRandomValue(Random rand);

        public abstract double Mean { get; }
        public abstract double StdDev { get; }

        public override Type GetElementType()
        {
            return typeof(T);
        }
    }
}
