﻿// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.6
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Esmf
{
    [Serializable]
    public class ParameterNonDimensional<T> : Parameter
    {
        private ParameterElement<T> _value;

        public ParameterNonDimensional(string name, int id, ParameterElement<T> value)
            : base(name, id)
        {
            _value = value;
        }

        public T GetBestGuessValue()
        {
            return _value.GetBestGuessValue();
        }

        public ParameterElement<T> Definition { get { return _value; } }

        public T GetRandomValue(Random rand)
        {
            return _value.GetRandomValue(rand);
        }
    }
}
