﻿// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.6
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Esmf
{
    [Serializable]
    public class ParameterOneDimensional<T> : Parameter
    {
        private ParameterElement<T>[] _value;

        public ParameterOneDimensional(string name, int id, ParameterElement<T>[] value)
            : base(name, id)
        {
            _value = value;
        }

        public JaggedArrayWrapper<T> GetBestGuessValues()
        {
            JaggedArrayWrapper<T> values = new JaggedArrayWrapper<T>(_value.Length);

            for (int i=0; i < _value.Length; i++)
            {
                values[i] = _value[i].GetBestGuessValue();
            }

            return values;
        }

        public ParameterElement<T>[] Definition { get { return _value; } }


        public JaggedArrayWrapper<T> GetRandomValues(Random rand)
        {
            JaggedArrayWrapper<T> values = new JaggedArrayWrapper<T>(_value.Length);

            for (int i = 0; i < _value.Length; i++)
            {
                values[i] = _value[i].GetRandomValue(rand);
            }

            return values;
        }
    }
}
