﻿// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.6
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Esmf
{
    public class ParameterValue1Dimensional<T> : ParameterValue, IEnumerable<ParameterValueElement1Dimensional<T>>
    {
        private JaggedArrayWrapper<T> _values;

        public ParameterValue1Dimensional(string name, int id, JaggedArrayWrapper<T> values)
            : base(name, id)
        {
            _values = new JaggedArrayWrapper<T>(values);
        }

        public T this[int index]
        {
            get
            {
                return _values[index];
            }
        }

        public int Length 
        {
            get
            {
                return _values.Length; 
            }
        }

        public void CopyTo(JaggedArrayWrapper<T> array)
        {
            _values.CopyTo(array);
        }

        public IEnumerator<ParameterValueElement1Dimensional<T>> GetEnumerator()
        {
            for (int i = 0; i < _values.Length; i++)
            {
                yield return new ParameterValueElement1Dimensional<T>(Name, Id, i, _values[i]);
            }
        }

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

    }
}
