﻿// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.6
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Esmf
{
    public class ParameterValue2Dimensional<T> : ParameterValue, IEnumerable<ParameterValueElement2Dimensional<T>>
    {
        private JaggedArrayWrapper2<T> _values;

        public ParameterValue2Dimensional(string name, int id, JaggedArrayWrapper2<T> values)
            : base(name, id)
        {
            _values = new JaggedArrayWrapper2<T>(values);                
        }

        public T this[int index1, int index2]
        {
            get
            {
                return _values[index1, index2];
            }
        }

        public int Length0
        { 
            get
            {
                return _values.Length0;
            } 
        }

        public int Length1 
        {
            get
            {
                return _values.Length1;
            }
        }

        public void CopyTo(JaggedArrayWrapper2<T> array)
        {
            _values.CopyTo(array);
        }

        public IEnumerator<ParameterValueElement2Dimensional<T>> GetEnumerator()
        {
            for (int i = 0; i < Length0; i++)
            {
                for (int l = 0; i < Length1; l++)
                {
                    yield return new ParameterValueElement2Dimensional<T>(Name, Id, i, l, _values[i, l]);
                }
            }
        }

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

    }
}
